/*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : Sep. 2006

 File          : slave.c

 Hardware      : Applicable to ADuC703x

 Description   : SPI slave is to use with master.c or master1.c
 				 the slaves receives values from the master, add 1 to 
				 recived value and send this value to slave.
		
*********************************************************************/
#include<ADuC7030.h>

void My_IRQ_Function(void);				//	IRQ Funtion Prototype 
int i,j;

int main(void) 
{
	IRQ = My_IRQ_Function;
	IRQEN = 0x20000;					// Enable SPI interrupt
//	FIQ = My_IRQ_Function;
//	FIQEN = 0x20001;					// Enable SPI fast interrupt and OR'ed interrupt
	
	GP2DAT = 0x02000000;				// Enable P2.1 (GPIO8) as an output
										// GPIO8 is connected to a LED on eval board
	GP0CON = 0x10001111;				// configure GPIO on SPI
	
	SPICON = 0x1409;					// enable SPI master in continuous transfer mode 
										// slave select will stay low during the all transmission

	while (1)							// infinite loop
	{
	}
					
}

/********************************************************************/
/*                                                                  */
/*		Interrupt Service Rountine									*/
/*                                                                  */
/********************************************************************/

void My_IRQ_Function() 
{
	if ((IRQSTA & 0x20000) != 0) 
//	if ((FIQSTA & 0x01) != 0) 
	{
		i++;
		if (i>1000) 
		{
			i=0;
			GP2DAT ^= 0x020000;			// Complement LED
		};
	j=SPIRX;							// read data and clear bit 4 in SPISTA
	SPITX = j+1;				  		// transmit command or any dummy data
//	FIQCLR = 0x0001;
	}
	return ;
}
